# IGA-WQ-MF analysis
### By Joaquin Cornejo

In this repository, we develop isogeometric analysis (IGA) with weighted quadrature (WQ) and matrix-free (MF) approaches. This code is based on algorithms described at:

- *Efficient matrix computation for tensor-product isogeometric analysis* by P. Antolin et al.
- *Tensor decompositions and applications* by T. Kolda and B. Bader
- *Fast formation of isogeometric Galerkin matrices by weighted quadrature* by F. Calabro et al.
- *Matrix-free weighted quadrature for a computationally efficient isogeometric k-method* by G. Sangalli and M. Tani
- *Analysis and practical use of flexible BiCG-Stab* by Jie Chen et al.
- *Isogeometric preconditioners based on fast solvers for the Sylvester equation* by G. Sangalli and M. Tani
- *Preconditioners for Isogeometric Analysis* by M. Montardini

## How to use it ?
This code is part of YETI project (see documentation).  